

package jcm.indata;
import java.io.*;
import java.util.*;
import static jcm.core.report.*;
import jcm.core.tls.fileio;

public class DataConvertor_CDIAC {
    

    /* Note: original input file was modified just to remove two unintended line endings in first row headings
     */

    public static void main(String[] args) {
	File inf=new File("/climate/data/gases/co2emit/cdiac/nation.1751_2006.csv");
	File outf=new File("/java/jcm/jcm-svn/src/data/hist/cdiacrows.csv");
	String header="Total CO2 emissions from fossil fuel burning (including gas flaring and cement production) from CDIAC 2009 (data to 2006) \n\n";
	
	
	try {
	    InputStream is= new FileInputStream(inf);
	    LineNumberReader lnr=new LineNumberReader(new BufferedReader(new InputStreamReader(is)));
	    StringTokenizer st;	String s;
	    List<String> as=new ArrayList();
	    List<String> a= new ArrayList();
	    String b, c=null;
	    int y, yn, e;
	    int endyear=2006;

	    deb(lnr.readLine()); deb(lnr.readLine()); deb(lnr.readLine()); //skip first three lines
	    
	    b="year"; for (y=1750; y<=endyear; y++) b+=", "+y;
	    
	    try {
		while ((s=lnr.readLine())!=null) {
            try {
		    st = new StringTokenizer(s, ",");
		    a.clear();
		    while (st.hasMoreTokens()) a.add(st.nextToken().trim());
		    
		    if (!(a.get(0).equals(c))) { //new country
			for ( ; y<=endyear; y++) b+=", - "; as.add(b+"\n"); // fill in the end of the old country, if data missing
			c=a.get(0); b=c;  y=1750;
		    }
		    
		    
            yn=Integer.valueOf(a.get(1));
		    for ( ; y<yn; y++) b+=", - "; //fill in gaps - can also be gaps in the middle of a sequence 
		    e=Integer.valueOf(a.get(2)); b+=", "+e; y++;
		    } catch (Exception ex) { deb("Error in line: " +b+ "\n Original: "+s + "\n"+ex); }
		}//while
		for ( ; y<=endyear; y++)  b+=", - ";  as.add(b+"\n");
		
	    } catch (IOException ex) { deb(ex); }
	    
	    is.close();
	    
	    FileWriter fw= new FileWriter(outf);
	    
	    fw.write(header);
	    for (String os : as)  fw.write(os);
	    fw.close();
	    
	} catch (IOException e) { deb(e); }
	
    }
    
} //end class